Non-Overlapping Intervals - Leetcode 435 - Python

  Рет қаралды 121,296

NeetCode

NeetCode

Күн бұрын

Пікірлер: 91
@raminanushiravani9524
@raminanushiravani9524 Жыл бұрын
your explanation are always great. Just one thing I noticed you said at 7:30, "removing the one that ends first", I think you meant keeping the one that ends first
@Harry-ko6ws
@Harry-ko6ws Жыл бұрын
yeah I think that is what he wanted to say :v I have to pause the video few times here just to verify
@KannanMavila
@KannanMavila Жыл бұрын
Came here to type the same :) I wish @NeetCode would pin this.
@riddhabose9653
@riddhabose9653 Жыл бұрын
exactly, even i was thinking the same
@bouzie8000
@bouzie8000 10 ай бұрын
The way this video took me an hour to undestand because of this mistake lol. Would have saved a lot of time if I had just continued watching to see he obviously made a mistake instead of pausing lol.
@c-mmon2257
@c-mmon2257 3 жыл бұрын
7:39 you have to remove which ends later and not first.
@ashsheth1482
@ashsheth1482 2 жыл бұрын
thanks for this comment
@willl5524
@willl5524 2 жыл бұрын
true, it should be keeping the one that ends first. That explains the code "prevEnd = min(end, prevEnd)"
@junjason4114
@junjason4114 2 жыл бұрын
The time should be 7:28
@murali1790able
@murali1790able 2 жыл бұрын
thanks for comment.
@murali1790able
@murali1790able 2 жыл бұрын
@@junjason4114 no time 6:35
@kaixuanhu8332
@kaixuanhu8332 3 жыл бұрын
you mean remove the interval which ends later right? not ends first, it is the greedy approach in order to avoid the later potentials overlapping
@yyyooohhhooo
@yyyooohhhooo 2 жыл бұрын
yup i was confused lmao
@PradiptaGitaya
@PradiptaGitaya 2 жыл бұрын
Yes. I was confused as well
@dingusagar
@dingusagar 7 ай бұрын
Thank God there are comments!😅
@ravig5413
@ravig5413 3 жыл бұрын
Are you the nicest person!! Neet. Thanks bud! for compiling/sharing the above lists and sharing the excel with the notes. All in 1 place. Awesome!! Be good!.
@NeetCode
@NeetCode 3 жыл бұрын
Thanks! Happy to help :)
@karthikkrishna8124
@karthikkrishna8124 5 ай бұрын
whre can i get the excel sheet?
@jonnatanortiz7159
@jonnatanortiz7159 Жыл бұрын
You literally give me hope when it comes to getting better at algorithms 🙏🏼
@johns3641
@johns3641 3 жыл бұрын
So happy every time I see a LC 75 problem explained. Thank you!
@hwang1607
@hwang1607 8 ай бұрын
came up with this after someone said to sort by the ends, may be more intuitive class Solution: def eraseOverlapIntervals(self, intervals: List[List[int]]) -> int: intervals.sort(key = lambda x : x[1]) cur = intervals[0] res = 0 for i in range(1, len(intervals)): if intervals[i][0] < cur[1]: res += 1 else: cur = intervals[i] return res
@deadsippy
@deadsippy 2 ай бұрын
thank you neetcode
@JulianBoilen
@JulianBoilen 2 жыл бұрын
7:33 "we want to remove the one that ends first" **crosses out one the ends last** 😕
@PradiptaGitaya
@PradiptaGitaya 2 жыл бұрын
I think he means to remove the one that ends later... If we remove the ends first, there are still possibilities other intervals may overlap.. Like: [1,5], [3,10], [7,12] First it will overlap on [1,5] and [3,10]. If we remove [1,5] unfortunately we will have another overlap on [3,10] with [7,12] But that's not the case if we remove [3,10]
@Moch117
@Moch117 Жыл бұрын
@@PradiptaGitaya Yeah I think so too. That part was confusing me because I thought it made more sense to remove the one that ends later
@NinjaN0ob
@NinjaN0ob 3 жыл бұрын
it is absolutely disgusting how your able to break down the problem and codify it so well, thank you so much I have learned so much from your videos
@mirceskiandrej
@mirceskiandrej 2 жыл бұрын
Wait, if we want to minimize the chance that an interval overlaps with the next one, don't we want to remove the longer one. The longer the interval is, the higher the chance it overlaps with something. Why did he say then that "of course we want to remove the shorter one" at 6:40???
@BorisIsASpider
@BorisIsASpider 2 жыл бұрын
In the example right after 6:40 he explains why u don't always want to remove the longest interval. A shorter interval can still cause multiple deletions
@rnelert
@rnelert 2 жыл бұрын
He just made a mistake and said a different thing that he meant.
@sentinel-y8l
@sentinel-y8l 2 жыл бұрын
If you sort the intervals by increasing period ends, then you don't need the min(end, prevEnd) inside the loop. You can also initialize prevEnd to -inf and iterate over the entire list instead of [1:].
@jeffwei
@jeffwei 2 жыл бұрын
Thanks, I was trying to figure out what the benefit to sorting by end was
@MistaT44
@MistaT44 2 жыл бұрын
literally the best explanations on youtube! so clear and concise.
@JaredDunn-r9c
@JaredDunn-r9c Жыл бұрын
This is such an amazing explanation. I can't thank you enough for all that you've done for us students.
@jonaskhanwald566
@jonaskhanwald566 3 жыл бұрын
Nice one. I'm a subscriber of Neetcode since it had less than 2k subscribers. Now its 31K. All the best to reach 100K soon.
@rajiththennakoon7392
@rajiththennakoon7392 3 жыл бұрын
Dude I love martha 😍
@jonaskhanwald566
@jonaskhanwald566 3 жыл бұрын
@@rajiththennakoon7392 I too. But not in last season.
@AK-kq1mk
@AK-kq1mk Жыл бұрын
322k
@xinyuwang7477
@xinyuwang7477 Жыл бұрын
I find sorting by the end time is easier. If there's overlap, just counter + 1 without other processing.
@azamatik3
@azamatik3 Жыл бұрын
thank u so much! When i saw this problem, I had no idea how to even get close to this problem, let alone a solution
@stith_pragya
@stith_pragya Жыл бұрын
Thank You So Much for this wonderful video........🙏🏻🙏🏻🙏🏻🙏🏻🙏🏻🙏🏻
@saketkumar9392
@saketkumar9392 2 ай бұрын
Great Explanation as always, thanks man.
@anupamkolay193
@anupamkolay193 Жыл бұрын
What an explanation! You make it look so easy. Thank you.
@arifrubayet8715
@arifrubayet8715 2 жыл бұрын
Neet! Why your voice is so satisfying bro? You r Great Man!!🤝
@amansingh.h716
@amansingh.h716 Жыл бұрын
ohh i was thinking about removing part but we just need to update the last value which is smaller between previous and current interval
@deepakreddy6528
@deepakreddy6528 Жыл бұрын
If anyone needs a simpler and more straightforward code, see if this helps: def eraseOverlapIntervals(self, intervals: List[List[int]]) -> int: intervals = sorted(intervals, key = lambda x : x[0]) res = 0 for i in range(1, len(intervals)): if intervals[i][0] < intervals[i-1][1]: res += 1 intervals[i][1] = min(intervals[i-1][1], intervals[i][1]) return res
@ChanChan-pg4wu
@ChanChan-pg4wu 2 жыл бұрын
Very crisp explanation and pretty smart!
@haniehh2160
@haniehh2160 2 жыл бұрын
Great Explanation!!! Where can I find the spreadsheet you showed at the beginning of the video?
@YawarMurtaza-z9k
@YawarMurtaza-z9k 7 ай бұрын
Would it be simpler if we count non-overlapping events then subtract those from total events?
@dinosauraesthetic
@dinosauraesthetic 3 ай бұрын
Can we think of it in a dynamic programming way?
@jaskaransingh0304
@jaskaransingh0304 Жыл бұрын
Great explanation
@mrshodz
@mrshodz 2 жыл бұрын
Why is the time complexity the complexity of the sort algorithm? I would assume it would be the time complexity equal to the O(sort algorithm) + O(algorithm to removed overlapping ranges)?
@jayshekarharkar8119
@jayshekarharkar8119 Жыл бұрын
Because O(algorithm to removed overlapping range) (O(n) ie. linear in time) is negligible compared to O(sort algorithm) (O(nlogn)) could & should be ignored.
@ancai5498
@ancai5498 Жыл бұрын
I think the logic should always remove the one end last, so it should have less chance of overlapping with the next interval.
@danielsun716
@danielsun716 2 жыл бұрын
@Neetcode, can you introduce the DP solution? Thanks
@blade99x
@blade99x 3 жыл бұрын
i got to the same solution except I was trying to remove the interval that had the bigger gap but it was failing. Once I made a small change to comparing the endpoints instead it worked. Could someone tell me why removing simply removing the bigger one doesnt work? Thanks
@treyamrich6096
@treyamrich6096 2 жыл бұрын
A larger interval does have a greater chance of overlapping with more intervals. However, it's countered by one case. Let's say the left interval has a size of 12 and overlaps with 1 interval (the right interval it's being compared with). The right interval has a size of 8 and overlaps with 3 intervals. In this case, removing the left interval would be wrong because the right interval still overlaps with 3 intervals. The logic is flawed. The greedy choice to remove the interval that ends the latest always works because that interval has a higher or equal chance of overlapping with more intervals in the future.
@shantanusingh3334
@shantanusingh3334 2 жыл бұрын
what will be the code if I need to remove those overlapping intervals and print the remaining list?
@anandkumar72
@anandkumar72 2 ай бұрын
best explanation
@lxu5148
@lxu5148 2 жыл бұрын
I wonder if it's feasible for you to do 1235. Maximum Profit in Job Scheduling, as well.
@AnkitaNallana
@AnkitaNallana 6 ай бұрын
THANK YOU FOR SORTING IT BY THE START TIMES!
@MIDNightPT4
@MIDNightPT4 3 жыл бұрын
Amazing explanation as always
@xuzack832
@xuzack832 Жыл бұрын
Hey Neet, I noticed you keep saying "remove the one that ends first" when you are not pointing to the one that ends first. I believe you meant "keep the one that ends first"?
@rajiththennakoon7392
@rajiththennakoon7392 3 жыл бұрын
What is the device/software are you using for drawing?
@NeetCode
@NeetCode 3 жыл бұрын
I just use a gaming mouse, with Paint3D
@coolmangame4141
@coolmangame4141 3 жыл бұрын
how are you so good with drawing with mouse? many people would love to do that lol
@fawadaliq
@fawadaliq 3 жыл бұрын
Wow. I can't event write this good with a drawing tablet.
@rohitheshwarwak5720
@rohitheshwarwak5720 3 ай бұрын
On an interview is it reasonable to expect an interviewer to ask for a semi-formal proof?
@supercarpro
@supercarpro 2 жыл бұрын
bro ur a fucking legend
@AmolGautam
@AmolGautam 11 ай бұрын
Thank you.
@adithyasn6315
@adithyasn6315 7 ай бұрын
This is the code for sorting based on second element on the list. this is slightly taking more time (measured based on custom timer method in my local ). I think because of lambda to run while sorting. But this looks simple code. class Solution: def eraseOverlapIntervals(self, intervals: List[List[int]]) -> int: res = 0 intervals = sorted(intervals, key=lambda i: i[1]) ele = intervals[0][1] for i in range(len(intervals)-1): if ele > intervals[i+1][0]: res+=1 else: ele = intervals[i+1][1] return res Happy Coding !!!!
@tejasnakhate
@tejasnakhate 3 жыл бұрын
This problem comes under label of dynamic programming. I wonder why?
@abhinay4200
@abhinay4200 2 жыл бұрын
got me confused as well
@thehdchan
@thehdchan 2 жыл бұрын
Dynamic programming is defined by finding the optimal solution to a subset of problems in order to solve the larger problem. Because it is using a greedy method algorithm, it's a dynamic programming problem.
@VivekMishrathetraveller
@VivekMishrathetraveller 3 жыл бұрын
Nice, can you also upload a video of critical connection LC 1192
@garitina987
@garitina987 2 жыл бұрын
Big fan of your stuff Neet, but if I had a suggestion, I wish you would do a much better job with catering to people who aren't solving these in python. For example, I'm doing C++ and didn't understand what the "start,end" was supposed to mean in the loop and had to do some digging to figure it out. :) Just a suggestion and hoping you can take it into consideration for the future. Regardless, you're videos are a god send!
@giridharjadala2182
@giridharjadala2182 2 жыл бұрын
Did anyone try doing this problem using Kruskal's algorithm ,maybe it might work ,give it go.
@VikasGupta-ok9lh
@VikasGupta-ok9lh Жыл бұрын
Understood
@ChazWinter
@ChazWinter Жыл бұрын
You keep saying "remove the one that ends first" when you mean "keep the one that ends first"
@bchen1403
@bchen1403 2 жыл бұрын
smooth
@osamaayman3765
@osamaayman3765 Жыл бұрын
Thankss
@mruduladdipalli5417
@mruduladdipalli5417 Жыл бұрын
I came up with same solution without watching this video, remembered your previous video where sorting was done on start value
@ryan-bo2xi
@ryan-bo2xi Жыл бұрын
how about this simple code def eraseOverlapIntervals(self, intervals: List[List[int]]) -> int: ans = 0 currentEnd = -math.inf for interval in sorted(intervals, key=lambda x: x[1]): if interval[0] >= currentEnd: currentEnd = interval[1] else: ans += 1 return ans
@edwardteach2
@edwardteach2 3 жыл бұрын
U a God
@lubeckable
@lubeckable 2 жыл бұрын
Idk but this solution doesn't work with java idk why
@cosmicheathen1955
@cosmicheathen1955 2 жыл бұрын
worked for me: public int eraseOverlapIntervals(int[][] intervals) { List res = new ArrayList(); Arrays.sort(intervals, (a, b) -> a[0] - b[0]); // sorting according to start int prevEnd = intervals[0][1]; int count=0; for(int i =1; i start ){ prevEnd = Math.min(prevEnd,end); count++; } else{ prevEnd =end; } } return count; }
Car Fleet - Leetcode 853 - Python
16:10
NeetCode
Рет қаралды 208 М.
Мясо вегана? 🧐 @Whatthefshow
01:01
История одного вокалиста
Рет қаралды 7 МЛН
Tuna 🍣 ​⁠@patrickzeinali ​⁠@ChefRush
00:48
albert_cancook
Рет қаралды 148 МЛН
Chain Game Strong ⛓️
00:21
Anwar Jibawi
Рет қаралды 41 МЛН
Top 7 Algorithms for Coding Interviews Explained SIMPLY
21:22
Codebagel
Рет қаралды 462 М.
How to Solve ANY LeetCode Problem (Step-by-Step)
12:37
Codebagel
Рет қаралды 328 М.
The Dome Paradox: A Loophole in Newton's Laws
22:59
Up and Atom
Рет қаралды 1,1 МЛН
What is mathematical thinking actually like?
9:44
Benjamin Keep, PhD, JD
Рет қаралды 25 М.
Coin Change - Dynamic Programming Bottom Up - Leetcode 322
19:23
5 Simple Steps for Solving Any Recursive Problem
21:03
Reducible
Рет қаралды 1,3 МЛН
Jump Game - Greedy - Leetcode 55
16:28
NeetCode
Рет қаралды 263 М.
Top K Frequent Elements - Bucket Sort - Leetcode 347 - Python
13:13
Implement Trie (Prefix Tree) - Leetcode 208
18:56
NeetCode
Рет қаралды 219 М.